
Vn.Basket = new Class
({
	Extends: Vn.Module

	,activate: function ()
	{
		this.conn.execQuery ('CALL basket_check ()',
			this.onBasketCheck.bind (this));
	}
	
	,onBasketCheck: function (resultSet)
	{
		var res = resultSet.fetchResult ();
		
		if (!res.next ())
			return;
		
		switch (res.get ('stat'))
		{
			case 'BAD_CONFIG':
			case 'NOT_EXISTS':
				this.onConfigureClick ();
				break;
			case 'UPDATED':
				(new Htk.Toast ()).showWarning (_('OrderItemsUpdated'));
				this.$('order').value = res.get ('order_id');
				break;
			case 'OK':
				this.$('order').value = res.get ('order_id');
				break;
		}
	}

	,onConfigureClick: function ()
	{
		this.hash.set ({'form': 'ecomerce/checkout'});
	}

	,onCheckoutClick: function ()
	{
		this.hash.set ({
			'form': 'ecomerce/confirm',
			'order': this.$('order').value
		});
	}

	,amountRender: function (renderer, form)
	{
		var amount = form.get ('amount');
		var grouping = form.get ('grouping');
	
		if (amount && grouping)
			renderer.value = amount / grouping;
		else
			renderer.value = null;
	}

	,onAmountChange: function (renderer, row, newValue)
	{
		var model = this.$('order-rows');
		model.set (row, 'amount', newValue * model.get (row, 'grouping'));
	}
	
	,featuresRender: function (renderer, form)
	{
		renderer.value = form.get ('Medida') +' '+ form.get ('Categoria') +' '+ form.get ('Color');
	}
	
	,stemsRender: function (renderer, form)
	{
		renderer.value = Vn.Value.format (form.get ('price'), '%.2d€') +' x '+ form.get ('amount');
	
		if (form.get ('amount') > form.get ('available'))
			renderer.td.className = 'available-exceeded';
		else
			renderer.td.className = '';
	}

	,subtotalRender: function (renderer, form)
	{
		renderer.value = this.subtotal (form);
	}

	,subtotal: function (form)
	{
		return form.get ('amount') * form.get ('price');
	}
	
	,availableRender: function (renderer, form)
	{
		if (form.get ('amount') > form.get ('avail'))
			renderer.value = 'unavailable';
		else
			renderer.value = 'invisible';
	}
});



