
Vn.Checkout = new Class
({
	Extends: Vn.Module

	,activate: function ()
	{
		this.autoStepLocked = true;
	}

	,onValuesReady: function ()
	{
		var orderForm = this.$('order-form');
		var defaultsForm = this.$('defaults');

		if (!(orderForm.ready && defaultsForm.ready))
			return;
		
		if (orderForm.numRows > 0)
		{
			(new Htk.Toast ()).showWarning (_('RememberReconfiguringImpact'));
			var i = orderForm;
			var date = i.get ('date_send');
		}
		else
		{
			var i = defaultsForm;
			var date = new Date ();
			
			if (i.get('delivery_method') != 'PICKUP')
				date.setTime (date.getTime () + 86400000);
		}
		
		this.$('delivery').value = date;
		this.$('method').value = i.get ('delivery_method');
		this.$('agency').value = i.get ('agency_id');
		this.$('address').value = i.get ('address_id');

		this.autoStepLocked = false;
	}

	,onConfirmClick: function ()
	{
		var query = 'CALL basket_configure (#delivery, #method, #agency, #address)';
	
		var batch = new Sql.Batch ();
		batch.addParam ('method', this.$('method'));
		batch.addParam ('delivery', this.$('delivery'));
		batch.addParam ('agency', this.$('agency'));
		batch.addParam ('address', this.$('address'));
	
		this.conn.execQuery (query,
			this.onBasketConfigured.bind (this), batch);
	}

	,onBasketConfigured: function (resultSet)
	{
		if (!resultSet.fetchResult ())
			return;
	
		if (this.$('order-form').numRows > 0)
		{
			(new Htk.Toast ()).showMessage (_('OrderUpdated'));
			window.history.back();
		}
		else
		{
			(new Htk.Toast ()).showMessage (_('OrderStarted'));
			this.hash.set ({'form': 'ecomerce/catalog'});
		}
	}

	,onCancelClick: function ()
	{
		if (this.$('order-form').numRows > 0)
			this.hash.set ({'form': 'ecomerce/basket'});
		else
			this.hash.set ({'form': 'ecomerce/orders'});
	}
	
	,agencySteps: ['method', 'date', 'address', 'agency', 'confirm-agency']
	,deliverySteps: ['method', 'date', 'address', null, 'confirm-delivery']
	,pickupSteps: ['method', 'date', 'pickup', null, 'confirm-pickup']
	
	,stepFunc: function (stepIndex)
	{
		var steps;
		var isDelivery;
	
		switch (this.$('rg-method').value)
		{
			case 'AGENCY':
				steps = this.agencySteps;
				isDelivery = true;
				break;
			case 'DELIVERY':
				steps = this.deliverySteps;
				isDelivery = true;
				break;
			case 'PICKUP':
			default:
				steps = this.pickupSteps;
				isDelivery = false;
				break;
		}

		var stepId = steps[stepIndex];
		
		if (!stepId)
			return null;

		switch (stepId)
		{
			case 'date':
				Vn.Node.setText (this.$('date-question'), isDelivery ?
					_('OrderDateDeliveryQuestion'):
					_('OrderDatePickupQuestion'));
				this.$('calendar').goToSelectedMonth ();
				break;
			case 'address':
				this.$('addresses').refresh ();
				break;
			case 'agency':
				this.$('agencies').refresh ();
				break;
			case 'pickup':
				this.$('agencies').refresh ();
				break;
		}
		
		return this.$(stepId +'-step');
	}
	
	,onFieldChange: function ()
	{
		if (!this.autoStepLocked)
			setTimeout (this.goNextStep.bind (this), 75);
	}
	
	,addressRenderer: function (builder, index)
	{
		builder.$('address-div').addEventListener ('click',
			this.onAddressClick.bind (this, index));
	}
	
	,onAddressClick: function (index)
	{
		this.$('address-form').row = index;
		this.$('address').value = this.$('address-form').get ('id');
		this.goNextStep ();
	}
	
	,goNextStep: function ()
	{
		this.$('assistant').moveNext ();
	}
	
	,calendarRestrict: function (date)
	{
		var now = new Date ();
		now.setHours (0,0,0,0);

		return date.getTime () >= now.getTime ()
			&& date.getDay () != 0;
	}
});

